"use strict";
/** @internal @packageDocumentation */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var m3u8stream_1 = __importDefault(require("m3u8stream"));
var protocols_1 = __importDefault(require("./protocols"));
var util_1 = require("./util");
var fromMedia = function (media, clientID, axiosInstance) { return __awaiter(void 0, void 0, void 0, function () {
    var link, res, r, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!validatemedia)
                    throw new Error('Invalid media object provided');
                _a.label = 1;
            case 1:
                _a.trys.push([1, 5, , 6]);
                link = util_1.appendURL(media.url, 'client_id', clientID);
                return [4 /*yield*/, axiosInstance.get(link, {
                        headers: {
                            'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/81.0.4044.129 Safari/537.36',
                            Accept: '*/*',
                            'Accept-Encoding': 'gzip, deflate, br'
                        },
                        withCredentials: true
                    })];
            case 2:
                res = _a.sent();
                if (!res.data.url)
                    throw new Error("Invalid response from Soundcloud. Check if the URL provided is correct: " + link);
                if (!(media.format.protocol === protocols_1["default"].PROGRESSIVE)) return [3 /*break*/, 4];
                return [4 /*yield*/, axiosInstance.get(res.data.url, {
                        withCredentials: true,
                        responseType: 'stream'
                    })];
            case 3:
                r = _a.sent();
                return [2 /*return*/, r.data];
            case 4: return [2 /*return*/, m3u8stream_1["default"](res.data.url)];
            case 5:
                err_1 = _a.sent();
                throw util_1.handleRequestErrs(err_1);
            case 6: return [2 /*return*/];
        }
    });
}); };
var validatemedia = function (media) {
    if (!media.url || !media.format)
        return false;
    return true;
};
exports["default"] = fromMedia;
